$regfile = "m16def.dat"
$crystal = 1000000

'##############################################################################

Config Porta = Output
Config Portc = Output

Config Timer0 = Timer , Prescale = 1024
Stop Timer0

Q1 Alias Pinb.7
Q2 Alias Pinb.6
Q3 Alias Pinb.5
Q4 Alias Pinb.4
Beep Alias Portb.0
Ring Alias Pinb.1
Coming_code Alias Pinb.3
'             6666666666
Config Pinb.0 = Output
Config Ring = Input
Config Coming_code = Input
Config Q1 = Input
Config Q2 = Input
Config Q3 = Input
Config Q4 = Input

Config Pind.7 = Output

'---------------------------------
On Timer0 Timeout_counter
Enable Timer0
Enable Interrupts

'---------------------------------

Ans_relay Alias Porta.3
Relay1 Alias Porta.0
Relay2 Alias Porta.1
Relay3 Alias Porta.2
Relay4 Alias Porta.4
Relay5 Alias Porta.5
Relay6 Alias Porta.6
Relay7 Alias Portc.7
Relay8 Alias Portc.6
Relay9 Alias Portc.5
Relay10 Alias Portc.4

'##############################################################################
Declare Sub Wait_for_call
Declare Sub Get_password
Declare Sub Get_task
Declare Sub Do_task

Declare Sub Verify_password
Declare Sub Connect
Declare Sub Disconnect

Declare Sub Sound_ok
Declare Sub Sound_error
Declare Sub Sound_goodbye

'##############################################################################

Dim Password_saved As Eram String * 5 , Ring_count_saved As Eram Byte
Dim Relay1_timeout_saved As Eram Word

Dim Password As String * 5 , Task As Byte , Ring_count As Byte
Dim Relay_status(10) As Eram Byte , Relay1_timeout As Word


Dim Time_out As Word , Code As Byte , Column As Byte , Error As Byte

Dim B1 As Byte , B2 As Byte
Dim W1 As Byte , W2 As Byte
Dim Str1 As String * 1 , Str2 As String * 5
Dim S1 As Single , S2 As Single

'----------------------------
Const True = 1
Const False = 0

Const Sharp = 12
Const Star = 11

'##############################################################################

'Program This Codes For Once Time Then Program Without This Codes
'Password_saved = "12345"
'Ring_count_saved = 3
'Relay1_timeout_saved = 5
'Do
'Loop

'Initial Hardware & Values
Reset Ans_relay : Reset Beep
Reset Relay1 : Reset Relay2 : Reset Relay3 : Reset Relay4 : Reset Relay5
Reset Relay6 : Reset Relay7 : Reset Relay8 : Reset Relay9 : Reset Relay10

B1 = Relay_status(1) : If B1 = True Then Set Relay1
B1 = Relay_status(2) : If B1 = True Then Set Relay2
B1 = Relay_status(3) : If B1 = True Then Set Relay3
B1 = Relay_status(4) : If B1 = True Then Set Relay4
B1 = Relay_status(5) : If B1 = True Then Set Relay5
B1 = Relay_status(6) : If B1 = True Then Set Relay6
B1 = Relay_status(7) : If B1 = True Then Set Relay7
B1 = Relay_status(8) : If B1 = True Then Set Relay8
B1 = Relay_status(9) : If B1 = True Then Set Relay9
B1 = Relay_status(10) : If B1 = True Then Set Relay10


Main:
Call Wait_for_call
Call Get_password
If Error = False Then Call Verify_password
If Error = True Then Goto Main


Do
   'Call Get_task
   Call Get_password
   If Error = False Then Call Do_task Else Goto Main
Loop




'-----------------------------------------------------------------------------
Sub Wait_for_call:
   'Initial values
   B1 = Ring_count_saved
   Do
      For Time_out = 1 To 5000
         If Ring = 0 Then
            Incr Ring_count
            'Check number of rings
            If Ring_count = B1 Then
               Call Connect : Call Sound_ok : Exit Sub
            End If
            '++++
            Time_out = 1 : Wait 1
         End If
         Waitms 1
      Next
      Ring_count = 0
   Loop
End Sub

'----------------------------------
Sub Get_password:
   'Intial values
   Call Sound_ok : Column = 0

   Password = "     "
   Do
      Error = True
      For Time_out = 1 To 8000
         Waitms 1
         If Coming_code = 1 Then
            Waitms 50 : Code = 0
            If Q1 = 1 Then Code = Code + 1
            If Q2 = 1 Then Code = Code + 2
            If Q3 = 1 Then Code = Code + 4
            If Q4 = 1 Then Code = Code + 8
            'Convert 10 to 0
            If Code = 10 Then Code = 0
            'Wait for coming code = 0
            Do
            Loop Until Coming_code = 0
            Waitms 50

            Error = False : Exit For
         End If
      Next

      Select Case Error
         Case True:
            Call Sound_error : Call Disconnect : Error = True : Exit Sub

         Case False:
            Select Case Code
               Case Sharp:
                  If Column <> 0 Then
                     Error = False : Exit Sub
                  End If

               Case Star:
                  Call Sound_error : Call Disconnect : Error = True : Exit Sub

               Case 0 To 9
                  If Column < 5 Then
                     Incr Column : Str1 = Str(code)
                     Mid(password , Column , 1) = Str1
                  Else
                     Call Sound_error
                  End If
            End Select
      End Select
   Loop
End Sub

'-----------------------------------
Sub Get_task:
   'Initial values
   Call Sound_ok : Task = 0

   Do
      Error = True
      For Time_out = 1 To 8000
            Waitms 1
            If Coming_code = 1 Then
            Waitms 50 : Code = 0
            If Q1 = 1 Then Code = Code + 1
            If Q2 = 1 Then Code = Code + 2
            If Q3 = 1 Then Code = Code + 4
            If Q4 = 1 Then Code = Code + 8
            'Convert 10 to 0
            If Code = 10 Then Code = 0
            'Wait for coming code = 0
            Do
            Loop Until Coming_code = 0
            Waitms 50

            Error = False : Exit For
         End If
      Next

      Select Case Error
         Case True:
            Call Sound_error : Call Disconnect : Error = True : Exit Sub

         Case False:
            Select Case Code
               Case Sharp:
                  If Task <> 0 Then
                     Error = False : Exit Sub
                  End If

               Case Star:
                  Call Sound_error : Call Disconnect : Error = True : Exit Sub

               Case 0 To 9 :
                  Task = Code
            End Select
      End Select
   Loop
End Sub

'----------------------------------
Sub Do_task:
   Password = Rtrim(password)
   Task = Val(password)

   Select Case Task
      'Control Relays
      Case 11 :
         Set Relay1 : Relay_status(1) = True
      Case 21 :
         Set Relay2 : Relay_status(2) = True
      Case 31 :
         Set Relay3 : Relay_status(3) = True
      Case 41 :
         Set Relay4 : Relay_status(4) = True
      Case 51 :
         Set Relay5 : Relay_status(5) = True
      Case 61 :
         Set Relay6 : Relay_status(6) = True
      Case 71 :
         Set Relay7 : Relay_status(7) = True
      Case 81 :
         Set Relay8 : Relay_status(8) = True
      Case 91 :
         Set Relay9 : Relay_status(9) = True
      Case 101 :
         Set Relay10 : Relay_status(10) = True


      Case 10 :
         Reset Relay1 : Relay_status(1) = False
      Case 20 :
         Reset Relay2 : Relay_status(2) = False
      Case 30 :
         Reset Relay3 : Relay_status(3) = False
      Case 40 :
         Reset Relay4 : Relay_status(4) = False
      Case 50 :
         Reset Relay5 : Relay_status(5) = False
      Case 60 :
         Reset Relay6 : Relay_status(6) = False
      Case 70 :
         Reset Relay7 : Relay_status(7) = False
      Case 80 :
         Reset Relay8 : Relay_status(8) = False
      Case 90 :
         Reset Relay9 : Relay_status(9) = False
      Case 100 :
         Reset Relay10 : Relay_status(10) = False


      'Chang Password
      Case 7:
         If Error = False Then Call Get_password
         If Error = False Then Password_saved = Password

      'Cahng number of rings for wait
      Case 8:
         Call Get_task
         If Error = False And Task > 0 Then Ring_count_saved = Task

'(
      Case 9:
         Call Get_task
         If Error = False Then
            Relay1_timeout = Task * 4 : Relay1_timeout_saved = Relay1_timeout
         End If
')

   End Select

   'Sounds
   If Error = False Then
      Call Sound_ok
   Else
      Call Sound_error
   End If

   'Call Disconnect
End Sub

'----------------------------------
Sub Verify_password:
   Str2 = Password_saved
   If Password = Str2 Then
      Call Sound_ok : Error = False
   Else
      Call Sound_error : Call Disconnect : Error = True
   End If
End Sub

'----------------------------------
Sub Connect:
   Set Ans_relay : Wait 1
End Sub

'----------------------------------
Sub Disconnect:
   Wait 1 : Reset Ans_relay
End Sub

'------------------------------- Sounds ---------------------------------------
Sub Sound_ok:
   Sound Portb.0 , 20 , 500
   Sound Portb.0 , 40 , 300
   Sound Portb.0 , 60 , 200
   Sound Portb.0 , 100 , 100
   Sound Portb.0 , 150 , 80
End Sub

'--------------
Sub Sound_error:
   Sound Portb.0 , 350 , 150
End Sub

'---------------
Sub Sound_goodbye:
   Sound Portb.0 , 150 , 80
   Sound Portb.0 , 100 , 100
   Sound Portb.0 , 60 , 200
   Sound Portb.0 , 40 , 300
   Sound Portb.0 , 20 , 500
End Sub

'---------------
Timeout_counter:
   Decr Relay1_timeout
   If Relay1_timeout = 0 Then
      Stop Timer0 : Reset Relay1
   End If
Return

'------------------------------------------------------------------------------
End